Add hg-to-git conversion utility.
[git/git.git] / git-sh-setup.sh
CommitLineData
b33e9666
LT
1#!/bin/sh
2#
ae2b0f15
JH
3# This is included in commands that either have to be run from the toplevel
4# of the repository, or with GIT_DIR environment variable properly.
5# If the GIT_DIR does not look like the right correct git-repository,
6# it dies.
b33e9666 7
365527ad
JH
8# Having this variable in your environment would break scripts because
9# you would cause "cd" to be be taken to unexpected places. If you
10# like CDPATH, define it for your interactive shell sessions without
11# exporting it.
12unset CDPATH
13
b33e9666 14die() {
8098a178 15 echo >&2 "$@"
b33e9666
LT
16 exit 1
17}
18
d025524d
FK
19usage() {
20 die "Usage: $0 $USAGE"
21}
22
f9474132
SP
23set_reflog_action() {
24 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
25 then
26 GIT_REFLOG_ACTION="$*"
27 export GIT_REFLOG_ACTION
28 fi
29}
30
4b441f47 31is_bare_repository () {
e0d10e1c 32 git-config --bool --get core.bare ||
4b441f47
JH
33 case "$GIT_DIR" in
34 .git | */.git) echo false ;;
35 *) echo true ;;
36 esac
37}
38
9fde9401
JH
39cd_to_toplevel () {
40 cdup=$(git-rev-parse --show-cdup)
41 if test ! -z "$cdup"
42 then
43 cd "$cdup" || {
44 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
45 exit 1
46 }
47 fi
48}
49
7eff28a9
SP
50require_work_tree () {
51 test $(is_bare_repository) = false ||
52 die "fatal: $0 cannot be used without a working tree."
53}
54
d025524d
FK
55if [ -z "$LONG_USAGE" ]
56then
57 LONG_USAGE="Usage: $0 $USAGE"
58else
59 LONG_USAGE="Usage: $0 $USAGE
60
61$LONG_USAGE"
62fi
63
64case "$1" in
cad1ed95 65 -h|--h|--he|--hel|--help)
d025524d
FK
66 echo "$LONG_USAGE"
67 exit
68esac
69
c8769f76 70# Make sure we are in a valid repository of a vintage we understand.
d025524d
FK
71if [ -z "$SUBDIRECTORY_OK" ]
72then
73 : ${GIT_DIR=.git}
120b0dfb
JH
74 GIT_DIR=$(GIT_DIR="$GIT_DIR" git-rev-parse --git-dir) || {
75 exit=$?
76 echo >&2 "You need to run this command from the toplevel of the working tree."
77 exit $exit
78 }
d025524d
FK
79else
80 GIT_DIR=$(git-rev-parse --git-dir) || exit
81fi
c8769f76 82: ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}